#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <string>
#include <stack>
#include <iomanip>
#include <ranges>

#define endl "\n"
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return x > y ? x = y, 1 : 0; }

using ll = long long;
const ll mod = 1e18 + 7;

#define LAM1(x) [&] (const auto &a) { return x; }
#define LAM2(x) [&] (const auto &a, const auto &b) { return x; }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//

const ll MAX_N = 1e5 + 10;
ll arr[MAX_N];
ll left[MAX_N];
ll right[MAX_N];
ll maxheight[MAX_N];
ll n;

ll dp[MAX_N];

ll wall_size(ll start, ll end) {
    if ((end - start) % 2 != 0) { return -mod; }
    ll len = end - start + 1;
    ll height = len / 2 + 1;
    for (ll i = 0; i <= len / 2; i ++) {
        if (arr[start + i] < 1 + i) {
            return -mod; 
        }
    }

    for (ll i = len / 2; i < len; i ++) {
        if (arr[start + i] < len - i) {
            return -mod; 
        }
    }

    return height * height;
}

void solve() { 
    std::cin >> n;
    for (ll i = 0; i < n; i ++) {
        std::cin >> arr[i];
    }

    for (ll i = 0; i < n; i ++) {
        dp[i] = 1;
        if (i != 0) { dp[i] = dp[i - 1]; }
        chkmax(dp[i], wall_size(0, i));
        for (ll j = 0; j < i; j ++) {
            chkmax(dp[i], dp[j] + wall_size(j + 1, i));
        }
    }
    std::cout << dp[n - 1] << endl;
}

signed main() {
#ifdef ONLINE_JUDGE
    std::ios_base::sync_with_stdio(false); std::cin.tie(NULL); std::cout.tie(NULL);
#endif
    ll t = 1;
    while (t --) { solve(); }
    return 0;
}
